Attribute VB_Name = "modGame"
Option Explicit

'   Diese Routine spielt einen Sound
Public Declare Function sndPlaySound Lib "winmm.dll" Alias "sndPlaySoundA" (ByVal lpszSoundName As String, ByVal uFlags As Long) As Long

Public C(51) As Integer     '52 Karten

Public CW As Long           'Kartenbreite
Public CH As Long           'Kartenhhe

'   Welcher Typ von Karte soll gezeichnet werden?
'   Vorderseite, Rckseite oder invertierte Vorderseite
Public Enum CARD_DRAW
  CARD_DRAW_FACE   '0
  CARD_DRAW_BACK   '1
  CARD_DRAW_INVERT '2
End Enum

'   Typ: Spieler
Type tSpieler
    sName As String     'Name des Spielers
    Anz As Integer      'Anzahl der Karten 'in der Hand'
    Mit As Boolean      'Spielt der Spieler mit?
    Card(3) As Integer  'Welche Karten sinds
    Weg As Integer      'Wieviel Karten hat dieser
    '                    Spieler vom Tisch weggerumt?
    Ges As Integer      'Gespielte Karte
End Type

Public S(3) As tSpieler 'Max. 4 Spieler gibt's

'   Typ: Spiel
Type tSpiel
    AnzS As Integer      'Anzahl der Spieler
    AktS As Integer      'Aktueller Spieler
    TiC As Integer       'Wieviel Karten sind "auf
    '                     dem Tisch"?
    ObC As Integer       'Die oberste Karte
    StC As Integer       'Bei welcher Karte wurde
    '                     das aufteilen gestoppt?
    NuC As Integer       'Wieviel Karten gibt es
    '                     noch?
End Type

Public Spiel As tSpiel

'   Die Kartennummern-Tabelle
'********************************
'        Kreuz  Karo  Herz  Pik
'     As   0     1     2     3
'   Zwei   4     5     6     7
'   Drei   8     9    10    11
'   Vier  12    13    14    15
'   Fnf  16    17    18    19
'  Sechs  20    21    22    23
' Sieben  24    25    26    27
'   Acht  28    29    30    31
'   Neun  32    33    34    35
'   Zehn  36    37    38    39
'   Bube  40    41    42    43
'   Dame  44    45    46    47
'  Knig  48    49    50    51
'********************************

'Die Bilder der Rckseiten
Public Enum CARD_BACK
  CARD_BACK_1 = 53
  CARD_BACK_2 '54
  CARD_BACK_3 '55
  CARD_BACK_4   '56
  CARD_BACK_5    '57
  CARD_BACK_6    '58
  CARD_BACK_7    '59
  CARD_BACK_8    '60
  CARD_BACK_9    '61
  CARD_BACK_10   '62
  CARD_BACK_11      '63
  CARD_BACK_12     '64
  CARD_BACK_13 '65
  CARD_BACK_EMPTY     '66 (leer)
  CARD_BACK_X         '67  (Freifeld mit 'X')
  CARD_BACK_O         '68  (Freifeld mit 'O')
End Enum

'   Initialisiert die Kartenbibliothek
Declare Function cdtInit Lib "Cards.dll" ( _
      dx As Long, dy As Long) As Long

'   Zeichnet eine Karte (mit Zusatzfunktionen)
Declare Function cdtDrawExt Lib "Cards.dll" (ByVal hDC As Long, _
      ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal _
      dy As Long, ByVal ordCard As Long, ByVal iDraw As Long, _
      ByVal Clr As Long) As Long

'   Zeichnet eine Karte
Declare Function cdtDraw Lib "Cards.dll" (ByVal hDC As Long, _
      ByVal X As Long, ByVal Y As Long, ByVal iCard As Long, _
      ByVal iDraw As Long, ByVal Clr As Long) As Long

'   Animiert den Hintergrund einer Karte
Declare Function cdtAnimate Lib "Cards.dll" (ByVal hDC As Long, _
      ByVal iCardBack As Long, ByVal X As Long, ByVal Y As Long, _
      ByVal iState As Long) As Long

'   De-initialisiert die Kartenbibliothek
Declare Function cdtTerm Lib "Cards.dll" () As Long

'*********************************************************
'      Folgende Routinen sind fr leichteres proggen
'*********************************************************

'   Diese Routine zeichnet eine Karte
Public Sub buCD(Xpos As Long, Ypos As Long, nCard As Integer, nTyp As CARD_DRAW)
    cdtDraw frmMain.pic.hDC, Xpos, Ypos, nCard, nTyp, vbWhite
End Sub

'   Diese Routine zeichnet nur die Rckseite einer Karte
Public Sub buCB(Xpos As Long, Ypos As Long, nCard As CARD_BACK, nTyp As CARD_DRAW)
    cdtDraw frmMain.pic.hDC, Xpos, Ypos, nCard, nTyp, vbWhite
End Sub


