Attribute VB_Name = "modSubs"
Option Explicit


'   Diese Routine mischt alle Karten per Zufallsgenerator
Public Sub buMi()
  Dim I As Long, R As Long
  Randomize
  
  For I = 0 To 51
    C(I) = -1
  Next I
  
  For I = 0 To 51
    R = Rnd() * 51
    While C(R) > -1
      R = (R + 7) Mod 52
    Wend
    C(R) = I
  Next I
End Sub

'   Diese Routine setzt die Attribute eines Spielers
Public Sub buSS(nSpieler As tSpieler, nAnz As Integer, nMit As Boolean, Optional nName As String, Optional nWeg As Integer, Optional nGes As Integer)
    With nSpieler
        .Anz = nAnz
        .Mit = nMit
        If nName <> "" Then .sName = nName
        If nWeg > -1 Then .Weg = .Weg + nWeg
        If nGes > -1 Then .Ges = nGes
    End With
End Sub

'   Diese Routine berprft ob die gespielte Karte
'   "einen Sinn hat"
Public Sub buCh(sSpieler As tSpieler, cGes As Integer, cOb As Integer)
'   Zuerst wird die gespielte Karte auf den Tisch gelegt
Spiel.TiC = Spiel.TiC + 1
    
'   Ist die gespielte Karte die Erste auf dem Tisch?
If cOb = -1 Then cOb = cGes: Exit Sub
    
    Select Case cGes
    '   Ist die gespielte Karte ein Bube
    Case 40 To 43
        '   Der Bube rumt immer alles
        sSpieler.Weg = sSpieler.Weg + Spiel.TiC
        Spiel.TiC = 0
        Spiel.ObC = -1
        sndPlaySound App.Path & "\" & "Boum.wav", 1
        Exit Sub
    End Select
'   Hat die gespielte Karte den gleichen Wert wie
'   die oberste auf dem Tisch?
    If buCheck(cOb, cGes) = True Then
        '   Alle Karten werden gerumt
        sSpieler.Weg = sSpieler.Weg + Spiel.TiC
        Spiel.TiC = 0
        Spiel.ObC = -1
        sndPlaySound App.Path & "\" & "Klirr.wav", 1
    End If

If Spiel.ObC > -1 Then Spiel.ObC = cGes
End Sub

'   Dieser Routine teilt die Karten fr eine neue Partie aus
Public Sub buT(cSt As Integer, cNu As Integer)
Dim I As Integer, _
    St As Integer, _
    J As Integer
    '   Falls die Anzahl der brigen Karten mit der
    '   Anzahl der Spieler nicht teilbar ist, geht
    '   es zum Notausgang
    If cNu < (4 * Spiel.AnzS) Then GoTo Notausgang
        St = cSt
        '   Der Spielerzhler
        For I = 0 To Spiel.AnzS - 1
            '   Der Spieler.Kartenzhler
            For J = 0 To 3
                '   Der I-Spieler bekommt die St-Karte
                S(I).Card(J) = C(St)
                St = St + 1
            Next J
          S(I).Anz = 4
          S(I).Ges = -1
        Next I
    '   Das Spiel bekommt wieder die "Gestoppt-Karte"
    Spiel.StC = St
    Spiel.NuC = 52 - (St)
    Exit Sub

Notausgang:
'   Die Not-Anzahl der Karten die ein Spieler bekommt
    Dim NotI As Integer
    Dim Rest As Integer
    '   Jeder Spieler bekommt die gleiche Anzahl von
    '   Karten und der Rest kommt auf den Tisch
    Rest = cNu Mod Spiel.AnzS
    St = cSt
    '   Die Karten-Notanzahl wird berechnet
    If Rest = 0 Then
        NotI = cNu / Spiel.AnzS
    Else
        NotI = (cNu - Rest) / Spiel.AnzS
    End If
    
    '   Da die Kartenanzahl mit 0 beginnt,
    '   muss die Notanzahl mit 1 substrahiert
    NotI = NotI - 1
    
    '       Der Spielerzhler
    For I = 0 To Spiel.AnzS - 1
        '   Der Spielerkarten-Zhler
        For J = 0 To NotI
            '   Der I-Spieler bekommt die St-Karte
            S(I).Card(J) = C(St)
            St = St + 1
        Next J
      S(I).Anz = NotI + 1
      S(I).Ges = -1
    Next I
    
    If Rest = 0 Then GoTo Rest0
    '   Der Rest wird auf den Tisch gelegt.
    '   Dabei wird nur die Letzte Karte gezeigt
    '   und die Anzahl der Karten auf dem Tisch
    '   wird um den Rest erweitert
    Spiel.ObC = C(51)
    Spiel.TiC = Spiel.TiC + Rest
Rest0:
    '   Es gibt keine Karten mehr
    Spiel.NuC = 0
    Spiel.StC = -1
End Sub

'   Diese Routine berprft ob Karte1 den gleichen
'   Wert wie Karte2 hat
Public Function buCheck(Co As Integer, Cg As Integer) As Boolean
Dim I As Integer, _
    L As Integer
    '
        buCheck = False
    '
    For I = 0 To 48 Step 4
        If Co = I Then
            If Cg = Co + 1 Or Cg = Co + 2 Or Cg = Co + 3 Then
                buCheck = True
                sndPlaySound App.Path & "\" & "Klirr.wav", 1
                Exit For
            End If
        ElseIf Co = I + 1 Then
            If Cg = Co + 1 Or Cg = Co + 2 Or Cg = Co - 1 Then
                buCheck = True
                sndPlaySound App.Path & "\" & "Klirr.wav", 1
                Exit For
            End If
        ElseIf Co = I + 2 Then
            If Cg = Co + 1 Or Cg = Co - 1 Or Cg = Co - 2 Then
                buCheck = True
                sndPlaySound App.Path & "\" & "Klirr.wav", 1
                Exit For
            End If
        ElseIf Co = I + 3 Then
            If Cg = Co - 1 Or Cg = Co - 2 Or Cg = Co - 3 Then
                buCheck = True
                sndPlaySound App.Path & "\" & "Klirr.wav", 1
                Exit For
            End If
        End If
    Next I
End Function

'   Diese Routine stellt den Gewinner fest
Public Sub buWin()
Dim I As Integer, _
    Gew As tSpieler

    '   Einen Wert braucht die Routine am Anfang
    Gew = S(0)
    
    '   Der Gewinner ist der, der die meisten
    '   Karten weggerumt hat
    For I = 0 To Spiel.AnzS - 1
        If S(I).Weg > Gew.Weg Then Gew = S(I)
    Next I

    sndPlaySound App.Path & "\" & "win.wav", 1
    
    '   Jetzt muss noch eine Message den Gewinner melden
    MsgBox "Der Gewinner dieser Runde ist " & _
            Gew.sName & " mit " & Gew.Weg & _
            " wegerumten Karten.", , _
            "Gewinner"
End Sub

